CPP(1)

NAME
cpp - The C Preprocessor

SYNOPSIS
cpp [-Dmacro[=defn]...] [-Umacro]
    [-Idir...] [-Wwarn...]
    [-M|-MM] [-MG] [-MF filename]
    [-MP] [-MQ target...] [-MT target...]
    [-x language] [-std=standard]
    infile outfile

Only the most useful options are listed here; see below for the remainder.

DESCRIPTION
The C preprocessor, often known as cpp, is a macro processor that is used automatically by the C compiler to transform your program before compilation. It is called a macro processor because it allows you to define macros, which are brief abbreviations for longer constructs.

The C preprocessor is intended to be used only with C, C++, and Objective-C source code. In the past, it has been abused as a general text processor. It will choke on input which does not obey C's lexical rules. For example, apostrophes will be interpreted as the beginning of character constants, and cause errors. Also, you cannot rely on it preserving characteristics of the input which are not significant to C-family languages. If a Makefile is preprocessed, all the hard tabs will be removed, and the Makefile will not work.

Having said that, you can often get away with using cpp on things which are not C. Other Algol-ish programming languages are often safe (Pascal, Ada, etc.) So is assembly, with caution. -traditional mode preserves more white space, and is otherwise more permissive. Many of the problems can be avoided by writing C or C++ style comments instead of native language comments, and keeping macros simple.

Wherever possible, you should use a preprocessor geared to the language you are writing in. Modern versions of the GNU assembler have macro facilities. Most high level programming languages have their own conditional compilation and inclusion mechanism. If all else fails, try a true general text processor, such as GNU M4.

C preprocessors vary in some details. This manual discusses the GNU C preprocessor, which provides a small superset of the features of ISO Standard C. In its default mode, the GNU C preprocessor does not do a few things required by the standard. These are features which are rarely, if ever, used, and may cause surprising changes to the meaning of a program which does not expect them. To get strict ISO Standard C, you should use the -std=c89 or -std=c99 options, depending on which version of the standard you want. To get all the mandatory diagnostics, you must also use -pedantic.

OPTIONS
The C preprocessor expects two file names as arguments, infile and outfile. The preprocessor reads infile together with any other files it specifies with #include. All the output generated by the combined input files is written in outfile.

Either infile or outfile may be -, which as infile means to read from standard input and as outfile means to write to standard output. Also, if either file is omitted, it means the same as if - had been specified for that file.

Unless otherwise noted, or the option ends in =, all options which take an argument may have that argument appear either immediately after the option, or with a space between option and argument: -Ifoo and -I foo have the same effect.

Many options have multi-letter names; therefore multiple single-letter options may not be grouped: -dM is very different from -d -M.

-D name
    Predefine name as a macro, with definition 1.

-D name=definition
    Predefine name as a macro, with definition definition. There are no restrictions on the contents of definition, but if you are invoking the preprocessor from a shell or shell-like program you may need to use the shell's quoting syntax to protect characters such as spaces that have a meaning in the shell syntax. If you use more than one -D for the same name, the rightmost definition takes effect.

    If you wish to define a function-like macro on the command line, write its argument list with surrounding parentheses before the equals sign (if any). Parentheses are meaningful to most shells, so you will need to quote the option. With sh and csh, -D'name(args...)=definition' works.

-U name
    Cancel any previous definition of name, either built in or provided with a -D option.

    All -imacros file and -include file options are processed after all -D and -U options.

-undef
    Do not predefine any system-specific macros. The common predefined macros remain defined.

-I dir
    Add the directory dir to the list of directories to be searched for header files. Directories named by -I are searched before the standard system include directories.

    It is dangerous to specify a standard system include directory in an -I option. This defeats the special treatment of system headers. It can also defeat the repairs to buggy system headers which GCC makes when it is installed.

-o file
    Write output to file. This is the same as specifying file as the second non-option argument to cpp. gcc has a different interpretation of a second non-option argument, so you must use -o to specify the output file.

-Wall
    Turns on all optional warnings which are desirable for normal code. At present this is -Wcomment and -Wtrigraphs. Note that many of the preprocessor's warnings are on by default and have no options to control them.

-Wcomment
-Wcomments
    Warn whenever a comment-start sequence /* appears in a /* comment, or whenever a backslash-newline appears in a // comment. (Both forms have the same effect.)

-Wtrigraphs
    Warn if any trigraphs are encountered. This option used to take effect only if -trigraphs was also specified, but now works independently. Warnings are not given for trigraphs within comments, as they do not affect the meaning of the program.

-Wtraditional
    Warn about certain constructs that behave differently in traditional and ISO C. Also warn about ISO C constructs that have no traditional C equivalent, and problematic constructs which should be avoided.

-Wimport
    Warn the first time #import is used.

-Wundef
    Warn whenever an identifier which is not a macro is encountered in an #if directive, outside of defined. Such identifiers are replaced with zero.

-Werror
    Make all warnings into hard errors. Source code which triggers warnings will be rejected.

-Wsystem-headers
    Issue warnings for code in system headers. These are normally unhelpful in finding bugs in your own code, therefore suppressed. If you are responsible for the system library, you may want to see them.

-w  Suppress all warnings, including those which GNU CPP issues by default.

-pedantic
    Issue all the mandatory diagnostics listed in the C standard. Some of them are left out by default, since they trigger frequently on harmless code.

-pedantic-errors
    Issue all the mandatory diagnostics, and make all mandatory diagnostics into errors. This includes mandatory diagnostics that GCC issues without -pedantic but treats as warnings.

-M  Instead of outputting the result of preprocessing, output a rule suitable for make describing the dependencies of the main source file. The preprocessor outputs one make rule containing the object file name for that source file, a colon, and the names of all the included files, including those coming from -include or -imacros command line options.

    Unless specified explicitly (with -MT or -MQ), the object file name consists of the basename of the source file with any suffix replaced with object file suffix. If there are many included files then the rule is split into several lines using \-newline. The rule has no commands.

-MM Like -M, but mention only the files included with "#include "file"" or with -include or -imacros command line options. System header files included with "#include <file>" are omitted.

-MF file
    When used with -M or -MM, specifies a file to write the dependencies to. This allows the preprocessor to write the preprocessed file to stdout normally. If no -MF switch is given, CPP sends the rules to stdout and suppresses normal preprocessed output.

-MG When used with -M or -MM, -MG says to treat missing header files as generated files and assume they live in the same directory as the source file. It suppresses preprocessed output, as a missing header file is ordinarily an error.

    This feature is used in automatic updating of makefiles.

-MP This option instructs CPP to add a phony target for each dependency other than the main file, causing each to depend on nothing. These dummy rules work around errors make gives if you remove header files without updating the Makefile to match.

    This is typical output:

            test.o: test.c test.h
            test.h:

-MT target
    Change the target of the rule emitted by dependency generation. By default CPP takes the name of the main input file, including any path, deletes any file suffix such as .c, and appends the platform's usual object suffix. The result is the target.

    An -MT option will set the target to be exactly the string you specify. If you want multiple targets, you can specify them as a single argument to -MT, or use multiple -MT options.

    For example, -MT '$(objpfx)foo.o' might give

            $(objpfx)foo.o: foo.c

-MQ target
    Same as -MT, but it quotes any characters which are special to Make. -MQ '$(objpfx)foo.o' gives

            $$(objpfx)foo.o: foo.c
    The default target is automatically quoted, as if it were given with -MQ.

-MD file
-MMD file
    -MD file is equivalent to -M -MF file, and -MMD file is equivalent to -MM -MF file.

    Due to limitations in the compiler driver, you must use these switches when you want to generate a dependency file as a side-effect of normal compilation.

-x c
-x c++
-x objective-c
-x assembler-with-cpp
    Specify the source language: C, C++, Objective-C, or assembly. This has nothing to do with standards conformance or extensions; it merely selects which base syntax to expect. If you give none of these options, cpp will deduce the language from the extension of the source file: .c, .cc, .m, or .S. Some other common extensions for C++ and assembly are also recognized. If cpp does not recognize the extension, it will treat the file as C; this is the most generic mode.

    Note: Previous versions of cpp accepted a -lang option which selected both the language and the standards conformance level. This option has been removed, because it conflicts with the -l option.

-std=standard
-ansi
    Specify the standard to which the code should conform. Currently cpp only knows about the standards for C; other language standards will be added in the future.

    standard may be one of:

    "iso9899:1990"
    "c89"
        The ISO C standard from 1990. c89 is the customary shorthand for this version of the standard.

        The -ansi option is equivalent to -std=c89.

    "iso9899:199409"
        The 1990 C standard, as amended in 1994.

    "iso9899:1999"
    "c99"
    "iso9899:199x"
    "c9x"
        The revised ISO C standard, published in December 1999. Before publication, this was known as C9X.

    "gnu89"
        The 1990 C standard plus GNU extensions. This is the default.

    "gnu99"
    "gnu9x"
        The 1999 C standard plus GNU extensions.

-I- Split the include path. Any directories specified with -I options before -I- are searched only for headers requested with "#include "file""; they are not searched for "#include <file>". If additional directories are specified with -I options after the -I-, those directories are searched for all #include directives.

    In addition, -I- inhibits the use of the directory of the current file directory as the first search directory for "#include "file"".

-nostdinc
    Do not search the standard system directories for header files. Only the directories you have specified with -I options (and the directory of the current file, if appropriate) are searched.

-nostdinc++
    Do not search for header files in the C++-specific standard directories, but do still search the other standard directories. (This option is used when building the C++ library.)

-include file
    Process file as if "#include "file"" appeared as the first line of the primary source file. However, the first directory searched for file is the preprocessor's working directory instead of the directory containing the main source file. If not found there, it is searched for in the remainder of the "#include "..."" search chain as normal.

    If multiple -include options are given, the files are included in the order they appear on the command line.

-imacros file
    Exactly like -include, except that any output produced by scanning file is thrown away. Macros it defines remain defined. This allows you to acquire all the macros from a header without also processing its declarations.

    All files specified by -imacros are processed before all files specified by -include.

-idirafter dir
    Search dir for header files, but do it after all directories specified with -I and the standard system directories have been exhausted. dir is treated as a system include directory.

-iprefix prefix
    Specify prefix as the prefix for subsequent -iwithprefix options. If the prefix represents a directory, you should include the final /.

-iwithprefix dir
-iwithprefixbefore dir
    Append dir to the prefix specified previously with -iprefix, and add the resulting directory to the include search path. -iwithprefixbefore puts it in the same place -I would; -iwithprefix puts it where -idirafter would.

    Use of these options is discouraged.

-isystem dir
    Search dir for header files, after all directories specified by -I but before the standard system directories. Mark it as a system directory, so that it gets the same special treatment as is applied to the standard system directories.

-fpreprocessed
    Indicate to the preprocessor that the input file has already been preprocessed. This suppresses things like macro expansion, trigraph conversion, escaped newline splicing, and processing of most directives. The preprocessor still recognizes and removes comments, so that you can pass a file preprocessed with -C to the compiler without problems. In this mode the integrated preprocessor is little more than a tokenizer for the front ends.

    -fpreprocessed is implicit if the input file has one of the extensions .i, .ii or .mi. These are the extensions that GCC uses for preprocessed files created by -save-temps.

-ftabstop=width
    Set the distance between tab stops. This helps the preprocessor report correct column numbers in warnings or errors, even if tabs appear on the line. If the value is less than 1 or greater than 100, the option is ignored. The default is 8.

-fno-show-column
    Do not print column numbers in diagnostics. This may be necessary if diagnostics are being scanned by a program that does not understand the column numbers, such as dejagnu.

-A predicate=answer
    Make an assertion with the predicate predicate and answer answer. This form is preferred to the older form -A predicate(answer), which is still supported, because it does not use shell special characters.

-A -predicate=answer
    Cancel an assertion with the predicate predicate and answer answer.

-A- Cancel all predefined assertions and all assertions preceding it on the command line. Also, undefine all predefined macros and all macros preceding it on the command line. (This is a historical wart and may change in the future.)

-dCHARS
    CHARS is a sequence of one or more of the following characters, and must not be preceded by a space. Other characters are interpreted by the compiler proper, or reserved for future versions of GCC, and so are silently ignored. If you specify characters whose behavior conflicts, the result is undefined.

    M   Instead of the normal output, generate a list of #define directives for all the macros defined during the execution of the preprocessor, including predefined macros. This gives you a way of finding out what is predefined in your version of the preprocessor. Assuming you have no file foo.h, the command

                touch foo.h; cpp -dM foo.h
        will show all the predefined macros.

    D   Like M except in two respects: it does not include the predefined macros, and it outputs both the #define directives and the result of preprocessing. Both kinds of output go to the standard output file.

    N   Like D, but emit only the macro names, not their expansions.

    I   Output #include directives in addition to the result of preprocessing.

-P  Inhibit generation of linemarkers in the output from the preprocessor. This might be useful when running the preprocessor on something that is not C code, and will be sent to a program which might be confused by the linemarkers.

-C  Do not discard comments. All comments are passed through to the output file, except for comments in processed directives, which are deleted along with the directive.

    You should be prepared for side effects when using -C; it causes the preprocessor to treat comments as tokens in their own right. For example, comments appearing at the start of what would be a directive line have the effect of turning that line into an ordinary source line, since the first token on the line is no longer a #.

-gcc
    Define the macros __GNUC__, __GNUC_MINOR__ and __GNUC_PATCHLEVEL__. These are defined automatically when you use gcc -E; you can turn them off in that case with -no-gcc.

-traditional
    Try to imitate the behavior of old-fashioned C, as opposed to ISO C.

-trigraphs
    Process trigraph sequences.

-remap
    Enable special code to work around file systems which only permit very short file names, such as MS-DOS.

-$  Forbid the use of $ in identifiers. The C standard allows implementations to define extra characters that can appear in identifiers. By default GNU CPP permits $, a common extension.

-h
--help
--target-help
    Print text describing all the command line options instead of preprocessing anything.

-v  Verbose mode. Print out GNU CPP's version number at the beginning of execution, and report the final form of the include path.

-H  Print the name of each header file used, in addition to other normal activities. Each name is indented to show how deep in the #include stack it is.

-version
--version
    Print out GNU CPP's version number. With one dash, proceed to preprocess as normal. With two dashes, exit immediately.

SEE ALSO
gpl(7), gfdl(7), fsf-funding(7), gcc(1), as(1), ld(1), and the Info entries for cpp, gcc, and binutils.

COPYRIGHT
Copyright (c) 1987, 1989, 1991, 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001 Free Software Foundation, Inc.

Permission is granted to copy, distribute and/or modify this document under the terms of the GNU Free Documentation License, Version 1.1 or any later version published by the Free Software Foundation. A copy of the license is included in the man page gfdl(7). This manual contains no Invariant Sections. The Front-Cover Texts are (a) (see below), and the Back-Cover Texts are (b) (see below).

(a) The FSF's Front-Cover Text is:

     A GNU Manual
(b) The FSF's Back-Cover Text is:

     You have freedom to copy and modify this GNU Manual, like GNU
     software.  Copies published by the Free Software Foundation raise
     funds for GNU development.